/*
 *	bookmark.h
 */

#ifndef	_BOOKMARK_H_
#define	_BOOKMARK_H_

#include <gbafs.h>
#include <xfont.h>

#define MAX_BOOKMARKS		63

#pragma	pack(1)

typedef struct _BMHEAD {
	vu8	sig[2];
	vu8	ver;
	vu8	size;
	vu8	nitems;
	vu8	curindex;
	vu8	reserved[26];
} BMHEAD, *PBMHEAD;

#define BMH_SIG		"BM"
#define BMH_VER		0x01

typedef struct _BMENTRY {
	vu8	flags;
	vu8	index;
	vu8	filesum[2];
	vu8	filesize[4];
	vu8	pageno[4];
	vu8	offset[4];
	vu8	fontname[XF_NAMELEN+1];
	vu8	fontsize;
	vu8	reserved[11];
} BMENTRY, *PBMENTRY;

#define BMF_INUSE	0x80

#pragma	pack()

typedef struct _BMPARAMS {
	PDIRENT		pdir;
	u32		pageno;
	u32		offset;
	PBMENTRY	pbm;
	u8		*fontname;
	u8		fontsize;
} BMPARAMS, *PBMPARAMS;

/*
 *	external functions
 */

void InitBookMark();
BOOL FindBookMark(PBMPARAMS parms);
BOOL BuildBookMark(PBMPARAMS parms);

#endif	// _BOOKMARK_H_

