/*
 *	sram.c
 */

#include "filer.h"

/*
 *	ReadSRAMByte
 */
void ReadSRAMByte(vu8 *sram, u8 *pv, int count)
{
	while (count-- > 0)
		*pv++ = *sram++;
}

/*
 *	WriteSRAMByte
 */
void WriteSRAMByte(vu8 *sram, u8 *pv, int count)
{
	while (count-- > 0)
		*sram++ = *pv++;
}

/*
 *	ReadSRAM8
 */
u8 ReadSRAM8(vu8 *sram)
{
	return *sram;
}

/*
 *	ReadSRAM32
 */
u32 ReadSRAM32(vu8 *sram)
{
	return sram[0] | (sram[1] << 8) | (sram[2] << 16) | (sram[3] << 24);
}

/*
 *	WriteSRAM8
 */
void WriteSRAM8(vu8 *sram, u8 v)
{
	*sram = v;
}

/*
 *	WriteSRAM16
 */
void WriteSRAM16(vu8 *sram, u16 v)
{
	*sram++ = (u8)v;
	*sram = (u8)(v >> 8);
}

/*
 *	WriteSRAM32
 */
void WriteSRAM32(vu8 *sram, u32 v)
{
	*sram++ = (u8)v;
	*sram++ = (u8)(v >> 8);
	*sram++ = (u8)(v >> 16);
	*sram = (u8)(v >> 24);
}

/*
 *	CompSRAM16
 */
int CompSRAM16(vu8 *sram, u16 *pv)
{
	if (*sram++ != *((u8 *)pv)++) return 1;
	if (*sram++ != *((u8 *)pv)++) return 1;

	return 0;
}

/*
 *	CompSRAM32
 */
int CompSRAM32(vu8 *sram, u32 *pv)
{
	if (*sram++ != *((u8 *)pv)++) return 1;
	if (*sram++ != *((u8 *)pv)++) return 1;
	if (*sram++ != *((u8 *)pv)++) return 1;
	if (*sram++ != *((u8 *)pv)++) return 1;

	return 0;
}

/*
 *	CompSRAMByte
 */
int CompSRAMByte(vu8 *sram, u8 *pv, int count)
{
	while (count-- > 0)
		if (*sram++ != *pv++)
			return 1;

	return 0;
}

