/*
 *	xfont.h
 */

#ifndef _XFONT_H_
#define _XFONT_H_

#include <gba.h>

#define NBPB		8

#define XF_NAMELEN	3

#pragma pack(1)

/*
 *	font file header
 */

typedef struct _XFONTHEAD {
	u8	sig[2];
	u8	ver;
	u8	size;
	u8	name[XF_NAMELEN+1];
	u16	flags;
	u8	width;
	u8	height;
	u8	xgap;
	u8	ygap;
	u16	unit;
	u16	scode;
	u16	ecode;
	u8	reserved[12];
} XFONTHEAD, *PXFONTHEAD;

#define XFONT_SIG	"FF"
#define XFONT_VER	0x01

#define XFF_FIXED	0x0000	// Fixed pitch font
#define XFF_PROP	0x0001	// Proportional font

#pragma pack()

/*
 *	Macros
 */

#define FO_SMALL	0
#define FO_NORMAL	1
#define FO_LAST		2

#define ISDBCSFONT(pxf)	(HIBYTE((pxf)->scode) != 0)

/*
 *	font object
 */

typedef struct _XFONTOBJ {
	PXFONTHEAD	pxf;
	int		(*code2index)(PXFONTHEAD pxf, u16 code);
	int		(*getcode)(u8 **ppcode);
} XFONTOBJ, *PXFONTOBJ;

/*
 *	globals
 */

extern int	XfontCodeType[];

/*
 *	functions
 */

/* xfont.c */
BOOL IsValidXfont(PXFONTHEAD pxf);
void XfontSetColor(int fgcolor, int bgcolor);
u8 *XfontGetFontName();
int XfontGetMaxCharWidth(u8 code);
int XfontGetCharHeight();
int XfontGetCharWidth(u8 **ppcode);
int XfontPutChar(int x, int y, u8 **ppcode);

/* xfontobj.c */
void XfontSetFontObject(int index, PXFONTHEAD pxa, PXFONTHEAD pxk);
void XfontSelectFontObject(int index);
PXFONTOBJ XfontGetFontObject(u8 code);

/* xindex.c */
int XfontKanjiCode2Index(PXFONTHEAD pxf, u16 code);
int XfontKanaCode2Index(PXFONTHEAD pxf, u16 code);
int XfontAnsiCode2Index(PXFONTHEAD pxf, u16 code);

#endif // _XFONT_H_

